C This SUBROUTINE computes the least squares regression of
C degree two. Input: NPNT (max 400) (x,y) pairs. Output: coefficients
C A(1) to A(3) of quadratic polynomial y=A(1)+A(2)x+A(3)x**2.
C
      SUBROUTINE MAP_UTIL_POLY(X,Y,NPNT,A)
C
      IMPLICIT NONE
      DOUBLE PRECISION X(6),Y(6),A(3),COEF(3,3)
      DOUBLE PRECISION RECIP,SAVEA,SAVEC,SMSQX,SMX2Y,SUMX,SUMX3
      DOUBLE PRECISION SUMX4,SUMXY,SUMY,TEMP,TEMP1,XMEAN,XPNT,YMEAN
      INTEGER I,J,NPNT
C
C     INITIALIZE VARIABLES
C
      SUMX   =  0.0D+00
      SUMY   =  0.0D+00
      SMSQX  =  0.0D+00
      SUMXY  =  0.0D+00
      SUMX3  =  0.0D+00
      SUMX4  =  0.0D+00
      SMX2Y  =  0.0D+00
C
C     INITIAL SUMMATIONS
C
      DO 20 I=1,NPNT
         SUMX   =  SUMX+X(I)
         SUMY   =  SUMY+Y(I)
         SUMXY  =  SUMXY+X(I)*Y(I)
         SMSQX  =  SMSQX+X(I)*X(I)
         SUMX3  =  SUMX3+X(I)*X(I)*X(I)
         SUMX4  =  SUMX4+X(I)*X(I)*X(I)*X(I)
         SMX2Y  =  SMX2Y+Y(I)*X(I)*X(I)
   20 CONTINUE
C
C     SET-UP FOR FURTHER USE
C
      XPNT   =  NPNT
      RECIP  =  1.0D+00/XPNT
      SAVEA  =  SMSQX-((SUMX*SUMX)/XPNT)
      SAVEC  =  SUMXY-((SUMX*SUMY)/XPNT)
C
C     MEASURES OF CENTRAL TENDENCY AND DISPERSION
C
      XMEAN  =  SUMX/XPNT
      YMEAN  =  SUMY/XPNT
C
C     INITIALIZE VARIABLES
C
      DO 40 I=1,3
         DO 30 J = 1,3
            COEF(I,J)=0.0D+00
  30     CONTINUE
  40  CONTINUE
C
C     LINEAR REGRESSION
C
      COEF(2,1) = SAVEC/SAVEA
C
C     QUADRATIC REGRESSION
C
      TEMP     = (SUMX*SMSQX)/XPNT
      TEMP1    =  SUMX3-TEMP
      COEF(3,2)= (((SMX2Y-((SUMY*SMSQX)/XPNT))/TEMP1)-COEF(2,1))/
     &           (((SUMX4-((SMSQX*SMSQX)/XPNT))/TEMP1)-(TEMP1/SAVEA))
      COEF(2,2)= (SAVEC-COEF(3,2)*(SUMX3-TEMP))/SAVEA
C
C     ESTIMATION OF REGRESSION COEFFICIENTS
C
      COEF(1,2)=  YMEAN-(COEF(2,2)*XMEAN)-(COEF(3,2)*(SMSQX*RECIP))
C
      A(1) = COEF(1,2)
      A(2) = COEF(2,2)
      A(3) = COEF(3,2)
      RETURN
      END
